apiVersion: tekton.dev/v1beta1
kind: Pipeline
metadata:
  labels:
    scan-code: "{{ scan_code_with }}"
    scan-image: "{{ scan_images_with }}"
    scan-repo: "{{ scan_repos_with }}"
    sign-image: "{{ sign_images_with }}"
    version: "{{ tekton_assets_version }}"
  name: node-s2i-build
  namespace: {{ buildns }}
spec:
  params:
{% if sonarqube_api_address | default(False) and tekton_scan_code %}
  - default: demo
    description: SonarQube Project Name
    name: sonarprojectname
    type: string
  - default: Demo
    description: SonarQube Project Description
    name: sonarprojectdescription
    type: string
{% endif %}
  - name: dstimage
    description: Destination image URL
    type: string
  - default: nodejs:master
    description: S2I Base Image
    name: fromimage
    type: string
  - description: git repository URL
    name: git-repo-url
    type: string
  - default: master
    description: git repository ref
    name: git-ref
    type: string
  tasks:
  - name: clone
    params:
    - name: url
      value: "$(params.git-repo-url)"
    - name: revision
      value: "$(params.git-ref)"
    taskRef:
      name: git-clone
    workspaces:
    - name: output
      workspace: git-repo
{% if tekton_scan_repo | default(False) %}
  - name: scan-repo
    retries: 2
    runAfter:
    - clone
    taskRef:
{% if scan_repos_with in [ 'truffle', 'trufflehog' ] %}
      name: scan-repo-trufflehog
{% else %}
      name: scan-repo-gitleaks
{% endif %}
    workspaces:
    - name: source
      workspace: git-repo
{% endif %}
  - name: build
    params:
    - name: dstimage
      value: "$(params.dstimage)"
    - name: fromimage
      value: "$(params.fromimage)"
{% if tekton_preferred_builder in [ 'buildah' ] %}
    - name: tlsverify
      value: "false"
{% elif tekton_preferred_builder in [ 'dind', 'dslim' ] %}
    - name: insecure
      value: "{{ docker_registry }}"
{% endif %}
    runAfter:
{% if tekton_scan_repo | default(False) %}
    - scan-repo
{% else %}
    - clone
{% endif %}
    taskRef:
{% if tekton_preferred_builder == 'img' %}
      name: node-s2i-build-img
{% elif tekton_preferred_builder == 'buildah' %}
      name: node-s2i-build-buildah
{% elif tekton_preferred_builder == 'buildkit' %}
      name: node-s2i-build-buildkit
{% elif tekton_preferred_builder == 'dind' %}
      name: node-s2i-build-dind
{% elif tekton_preferred_builder == 'dslim' %}
      name: node-s2i-build-dslim
{% else %}
      name: node-s2i-build-kaniko
{% endif %}
    workspaces:
    - name: source
      workspace: git-repo
{% if sonarqube_api_address | default(False) and tekton_scan_code %}
  - name: scan-code
    params:
    - name: sonarprojectdescription
      value: "$(params.sonarprojectdescription)"
    - name: sonarprojectname
      value: "$(params.sonarprojectname)"
    retries: 2
    runAfter:
    - build
    taskRef:
      name: node-scan
    workspaces:
    - name: source
      workspace: git-repo
{% endif %}
{% if ((clair_api_address | default(False)) or (trivy_api_address | default(False))) and tekton_scan_images %}
  - name: scan-image
    params:
    - name: dstimage
      value: "$(params.dstimage)"
    retries: 2
    runAfter:
    - build
    taskRef:
{% if trivy_api_address | default(False) %}
      name: scan-image-trivy
{% else %}
      name: scan-image-clair
{% endif %}
{% endif %}
{% if tekton_sign_images and (found_cosign_secret | default(False) or found_gpg_secret | default(False)) %}
  - name: sign-image
    params:
    - name: dstimage
      value: "$(params.dstimage)"
    - name: IMAGE_DIGEST
      value: "$(tasks.build.results.IMAGE_DIGEST)"
    retries: 2
    runAfter:
{% if ((clair_api_address | default(False)) or (trivy_api_address | default(False))) and tekton_scan_images %}
    - scan-image
{% else %}
    - build
{% endif %}
    taskRef:
{% if found_cosign_secret | default(False) %}
      name: sign-image-cosign
{% else %}
      name: sign-image-gpg
{% endif %}
    when:
    - input: "$(workspaces.sigsecret.bound)"
      operator: in
      values: ["true"]
    workspaces:
    - name: sigsecret
      workspace: sigsecret
{% endif %}
  workspaces:
  - name: sigsecret
    optional: true
  - name: git-repo
